## pytorch-scatter 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(torchscatter)
set(CMAKE_CXX_STANDARD 14)
set(TORCHSCATTER_VERSION 2.1.2)

option(WITH_CUDA "Enable CUDA support" OFF)
option(WITH_PYTHON "Link to Python when building" ON)

if(WITH_CUDA)
  enable_language(CUDA)
  add_definitions(-D__CUDA_NO_HALF_OPERATORS__)
  add_definitions(-DWITH_CUDA)
  set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} --expt-relaxed-constexpr")
endif()

if (WITH_PYTHON)
  add_definitions(-DWITH_PYTHON)
  find_package(Python3 COMPONENTS Development)
endif()
find_package(Torch REQUIRED)

file(GLOB HEADERS csrc/*.h)
file(GLOB OPERATOR_SOURCES csrc/cpu/*.h csrc/cpu/*.cpp csrc/*.cpp)
if(WITH_CUDA)
  file(GLOB OPERATOR_SOURCES ${OPERATOR_SOURCES} csrc/cuda/*.h csrc/cuda/*.cu)
endif()

add_library(${PROJECT_NAME} SHARED ${OPERATOR_SOURCES})
target_link_libraries(${PROJECT_NAME} PRIVATE ${TORCH_LIBRARIES})
if (WITH_PYTHON)
  target_link_libraries(${PROJECT_NAME} PRIVATE Python3::Python)
endif()
set_target_properties(${PROJECT_NAME} PROPERTIES EXPORT_NAME TorchScatter)

target_include_directories(${PROJECT_NAME} INTERFACE
  "$<BUILD_INTERFACE:${HEADERS}>"
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(TORCHSCATTER_CMAKECONFIG_INSTALL_DIR "share/cmake/TorchScatter" CACHE STRING "install path for TorchScatterConfig.cmake")

configure_package_config_file(cmake/TorchScatterConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/TorchScatterConfig.cmake"
  INSTALL_DESTINATION ${TORCHSCATTER_CMAKECONFIG_INSTALL_DIR})

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/TorchScatterConfigVersion.cmake
  VERSION ${TORCHSCATTER_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/TorchScatterConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/TorchScatterConfigVersion.cmake
  DESTINATION ${TORCHSCATTER_CMAKECONFIG_INSTALL_DIR})

install(TARGETS ${PROJECT_NAME}
  EXPORT TorchScatterTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

install(EXPORT TorchScatterTargets
  NAMESPACE TorchScatter::
  DESTINATION ${TORCHSCATTER_CMAKECONFIG_INSTALL_DIR})

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
install(FILES
  csrc/cpu/scatter_cpu.h
  csrc/cpu/segment_coo_cpu.h
  csrc/cpu/segment_csr_cpu.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cpu)
if(WITH_CUDA)
  install(FILES
    csrc/cuda/scatter_cuda.h
    csrc/cuda/segment_coo_cuda.h
    csrc/cuda/segment_csr_cuda.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cuda)
endif()

if(WITH_CUDA)
  set_property(TARGET torch_cuda PROPERTY INTERFACE_COMPILE_OPTIONS "")
  set_property(TARGET torch_cpu PROPERTY INTERFACE_COMPILE_OPTIONS "")
endif()

=== docs/Makefile ===
SPHINXBUILD := sphinx-build
SPHINXPROJ := pytorch_scatter
SOURCEDIR := source
BUILDDIR := build

.PHONY: help Makefile

%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)"

=== docs/requirements.txt ===
https://download.pytorch.org/whl/cpu/torch-1.11.0%2Bcpu-cp38-cp38-linux_x86_64.whl
sphinx>=3
sphinx_rtd_theme

=== debian/changelog ===
pytorch-scatter (2.1.2-4) unstable; urgency=medium

  * d/control: fix incorrect Breaks version of python3-torch-sparse
    (should be << 0.6.18-3)

 -- Shengqi Chen <harry@debian.org>  Mon, 24 Feb 2025 21:51:11 +0800

pytorch-scatter (2.1.2-3) unstable; urgency=medium

  * Team upload.
  * d/control: breaks python3-torch-sparse (<< 0.6.18-2) due to libtorch
    incompatibility.

 -- Shengqi Chen <harry@debian.org>  Mon, 24 Feb 2025 13:57:47 +0800

pytorch-scatter (2.1.2-2) unstable; urgency=medium

  * Team upload.
  * d/control: bump std-ver to 4.7.1 (no changes required).
  * d/rules: make dh_auto_clean more robust.
  * Rebuild for libtorch2.6 transition.

 -- Shengqi Chen <harry@debian.org>  Mon, 24 Feb 2025 00:07:07 +0800

pytorch-scatter (2.1.2-1) unstable; urgency=medium

  * New upstream version 2.1.2
  * Build on default Python only as python3-torch is built only there
    (Closes: #1058201)

 -- Andrius Merkys <merkys@debian.org>  Wed, 13 Dec 2023 07:25:18 -0500

pytorch-scatter (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1
  * Switch watch file to GitHub.

 -- Andrius Merkys <merkys@debian.org>  Sun, 17 Sep 2023 15:25:49 -0400

pytorch-scatter (2.1.0-2) unstable; urgency=medium

  * Set upstream metadata fields: Repository.

 -- Andrius Merkys <merkys@debian.org>  Wed, 08 Mar 2023 02:22:25 -0500

pytorch-scatter (2.1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1031272)

 -- Andrius Merkys <merkys@debian.org>  Tue, 14 Feb 2023 08:15:55 -0500

=== debian/control ===
Source: pytorch-scatter
Section: science
Priority: optional
Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 libtorch-dev,
 pybind11-dev,
 python3,
 python3-pytest <!nocheck>,
 python3-setuptools,
 python3-torch,
Testsuite: autopkgtest-pkg-pybuild
Standards-Version: 4.7.1
Homepage: https://github.com/rusty1s/pytorch_scatter
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-scatter
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-scatter.git

Package: python3-torch-scatter
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Breaks: python3-torch-sparse (<< 0.6.18-3)
Description: PyTorch Extension Library of Optimized Scatter Operations
 This package consists of a small extension library of highly optimized sparse
 update (scatter and segment) operations for the use in PyTorch, which are
 missing in the main package. Scatter and segment operations can be roughly
 described as reduce operations based on a given "group-index" tensor. Segment
 operations require the "group-index" tensor to be sorted, whereas scatter
 operations are not subject to these requirements.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export PYBUILD_NAME = torch-scatter

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	-dh_auto_clean
	-$(RM) -rf .pybuild/

# If you need to rebuild the Sphinx documentation:
# Add sphinxdoc to the dh --with line.
#
# And uncomment the following lines.
#execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
#execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
#execute_after_dh_auto_build-indep:
#	PYTHONPATH=. python3 -m sphinx -N -bhtml \
#	docs/ build/html # HTML generator
#	PYTHONPATH=. python3 -m sphinx -N -bman \
#	docs/ build/man # Manpage generator

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/rusty1s/pytorch_scatter/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
